import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

//   
class Vertex {
	int id;

	public Vertex(int id) {
		this.id = id;
	}
}

//   
class Edge {
	int id, weight, used;
	Vertex nachalo, krai;

	public Edge(int id, Vertex begin, Vertex end, int weight) {
		this.id = id;
		this.nachalo = begin;
		this.krai = end;
		this.weight = weight;
		this.used = 0;
	}
}

public class Osnoven {
	//    
	private static ArrayList<Vertex> vurhove = new ArrayList<Vertex>();
	private static ArrayList<Edge> magistrali = new ArrayList<Edge>();
	private static ArrayList<Integer> finalArray = new ArrayList<Integer>();

	//     
	private static void DobaviMagistrala(int number, int begin, int end,
			int weight) {
		Edge lane = new Edge(number, vurhove.get(begin), vurhove.get(end),
				weight);
		magistrali.add(lane);
	}

	public static void main(String[] args) throws IOException {
		//   
		ArrayList<String> fileInfo = new ArrayList<>();
		BufferedReader buffRead = new BufferedReader(new FileReader("graph.in"));
		String line = buffRead.readLine();
		while (line != null) {
			fileInfo.add(line);
			line = buffRead.readLine();
		}
		buffRead.close();

		//       
		String[] splits = fileInfo.get(0).split(" ");
		int cities = Integer.parseInt(splits[0]), highways = Integer
				.parseInt(splits[1]);

		//   
		int z = 0;
		while (z < highways) {
			vurhove.add(new Vertex(z));
			z++;
		}

		//   
		int first, second, distance;
		for (int i = 1; i <= highways; i++) {
			splits = fileInfo.get(i).split(" ");
			first = Integer.parseInt(splits[0]);
			second = Integer.parseInt(splits[1]);
			distance = Integer.parseInt(splits[2]);

			DobaviMagistrala(i, first, second, distance);
			DobaviMagistrala(i, second, first, distance);
		}

		//   
		Algorithm nai_kratuk_put = new Algorithm(magistrali, vurhove.get(1));
		ArrayList<Vertex> path;

		//   - 
		int dest = 2, p = 0, k = 0;
		while (dest <= cities) {
			path = nai_kratuk_put.getPath(vurhove.get(dest));
			p = 0;
			while (p < (path.size() - 1)) {
				k = 0;
				while (k < magistrali.size()) {
					if (magistrali.get(k).nachalo.equals(path.get(p))
							&& magistrali.get(k).krai.equals(path.get(p + 1))
							&& magistrali.get(k).used == 0) {
						finalArray.add(magistrali.get(k).id);
						magistrali.get(k).used = 1;
					}
					k++;
				}
				p++;
			}
			dest++;
		}

		//   
		BufferedWriter write_to_file = new BufferedWriter(new FileWriter(
				"graph.out"));
		int n_spisak = 0;
		while (n_spisak < finalArray.size()) {
			write_to_file.write((finalArray.get(n_spisak)).intValue() + "\n");
			n_spisak++;
		}
		write_to_file.close();

	}

}
